diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-constants.h ns-3.38/src/lr-wpan/model/lr-wpan-constants.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-constants.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/lr-wpan/model/lr-wpan-constants.h	2023-03-16 20:54:23.632868500 -0700
@@ -0,0 +1,129 @@
+/*
+ * Copyright (c) 2011 The Boeing Company
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors:
+ *  Gary Pei <guangyu.pei@boeing.com>
+ *  kwong yin <kwong-sang.yin@boeing.com>
+ *  Tom Henderson <thomas.r.henderson@boeing.com>
+ *  Sascha Alexander Jopen <jopen@cs.uni-bonn.de>
+ *  Erwan Livolant <erwan.livolant@inria.fr>
+ *  Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
+ */
+
+#ifndef LR_WPAN_CONSTANTS_H
+#define LR_WPAN_CONSTANTS_H
+
+#include <cstdint>
+
+namespace ns3
+{
+namespace lrwpan
+{
+
+/**
+ * \defgroup LrWpanConstants
+ * \ingroup lr-wpan
+ *
+ * Contains common parameters about LR-WPAN that can be reused in multiple files.
+ * These parameters are defined in the IEEE 802.15.4-2011 standard and adopt the
+ * same names as in the standard.
+ *
+ * @{
+ */
+
+///////////////////
+// PHY constants //
+///////////////////
+
+/**
+ * The maximum packet size accepted by the PHY.
+ * See Table 22 in section 6.4.1 of IEEE 802.15.4-2006
+ */
+constexpr uint32_t aMaxPhyPacketSize{127};
+
+/**
+ * The turnaround time in symbol periods for switching the transceiver from RX to TX or
+ * vice-versa.
+ * See Table 22 in section 6.4.1 of IEEE 802.15.4-2006
+ */
+constexpr uint32_t aTurnaroundTime{12};
+
+///////////////////
+// MAC constants //
+///////////////////
+
+/**
+ * The minimum number of octets added by the MAC sublayer to the PSDU.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aMinMPDUOverhead{9};
+
+/**
+ * Length of a superframe slot in symbols. Defaults to 60 symbols in each superframe slot.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aBaseSlotDuration{60};
+
+/**
+ * Number of a superframe slots per superframe. Defaults to 16.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aNumSuperframeSlots{16};
+
+/**
+ * Length of a superframe in symbols. Defaults to aBaseSlotDuration * aNumSuperframeSlots in
+ * symbols.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aBaseSuperframeDuration{aBaseSlotDuration * aNumSuperframeSlots};
+
+/**
+ * The number of consecutive lost beacons that will cause the MAC sublayer of a receiving device to
+ * declare a loss of synchronization.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aMaxLostBeacons{4};
+
+/**
+ * The maximum size of an MPDU, in octets, that can be followed by a Short InterFrame Spacing (SIFS)
+ * period.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aMaxSIFSFrameSize{18};
+
+/**
+ * Number of symbols per CSMA/CA time unit, default 20 symbols.
+ */
+constexpr uint32_t aUnitBackoffPeriod{20};
+
+/**
+ * The maximum number of octets added by the MAC sublayer to the MAC payload o a a beacon frame.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aMaxBeaconOverhead{75};
+
+/**
+ * The maximum size, in octets, of a beacon payload.
+ * See IEEE 802.15.4-2011, section 6.4.1, Table 51.
+ */
+constexpr uint32_t aMaxBeaconPayloadLenght{aMaxPhyPacketSize - aMaxBeaconOverhead};
+
+/** @} */
+
+} // namespace lrwpan
+} // namespace ns3
+
+#endif // LR_WPAN_CONSTANTS_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-csmaca.cc ns-3.38/src/lr-wpan/model/lr-wpan-csmaca.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-csmaca.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-csmaca.cc	2023-03-16 20:54:23.632868500 -0700
@@ -22,6 +22,8 @@
 
 #include "lr-wpan-csmaca.h"
 
+#include "lr-wpan-constants.h"
+
 #include <ns3/log.h>
 #include <ns3/random-variable-stream.h>
 #include <ns3/simulator.h>
@@ -59,7 +61,6 @@
     m_macMinBE = 3;
     m_macMaxBE = 5;
     m_macMaxCSMABackoffs = 4;
-    m_aUnitBackoffPeriod = 20; // symbols
     m_random = CreateObject<UniformRandomVariable>();
     m_BE = m_macMinBE;
     m_ccaRequestRunning = false;
@@ -169,20 +170,6 @@
     return m_macMaxCSMABackoffs;
 }
 
-void
-LrWpanCsmaCa::SetUnitBackoffPeriod(uint64_t unitBackoffPeriod)
-{
-    NS_LOG_FUNCTION(this << unitBackoffPeriod);
-    m_aUnitBackoffPeriod = unitBackoffPeriod;
-}
-
-uint64_t
-LrWpanCsmaCa::GetUnitBackoffPeriod() const
-{
-    NS_LOG_FUNCTION(this);
-    return m_aUnitBackoffPeriod;
-}
-
 Time
 LrWpanCsmaCa::GetTimeToNextSlot() const
 {
@@ -219,8 +206,8 @@
 
     // get a close value to the the boundary in symbols
     elapsedSuperframeSymbols = elapsedSuperframe.GetSeconds() * symbolRate;
-    symbolsToBoundary =
-        m_aUnitBackoffPeriod - std::fmod((double)elapsedSuperframeSymbols, m_aUnitBackoffPeriod);
+    symbolsToBoundary = lrwpan::aUnitBackoffPeriod -
+                        std::fmod((double)elapsedSuperframeSymbols, lrwpan::aUnitBackoffPeriod);
 
     timeAtBoundary = Seconds((double)(elapsedSuperframeSymbols + symbolsToBoundary) / symbolRate);
 
@@ -308,7 +295,7 @@
     }
 
     randomBackoff =
-        Seconds((double)(m_randomBackoffPeriodsLeft * GetUnitBackoffPeriod()) / symbolRate);
+        Seconds((double)(m_randomBackoffPeriodsLeft * lrwpan::aUnitBackoffPeriod) / symbolRate);
 
     if (IsUnSlottedCsmaCa())
     {
@@ -330,14 +317,14 @@
                      << randomBackoff.As(Time::S) << ")");
 
         NS_LOG_DEBUG("Backoff periods left in CAP: "
-                     << ((timeLeftInCap.GetSeconds() * symbolRate) / m_aUnitBackoffPeriod) << " ("
-                     << (timeLeftInCap.GetSeconds() * symbolRate) << " symbols or "
+                     << ((timeLeftInCap.GetSeconds() * symbolRate) / lrwpan::aUnitBackoffPeriod)
+                     << " (" << (timeLeftInCap.GetSeconds() * symbolRate) << " symbols or "
                      << timeLeftInCap.As(Time::S) << ")");
 
         if (randomBackoff >= timeLeftInCap)
         {
             uint64_t usedBackoffs =
-                (double)(timeLeftInCap.GetSeconds() * symbolRate) / m_aUnitBackoffPeriod;
+                (double)(timeLeftInCap.GetSeconds() * symbolRate) / lrwpan::aUnitBackoffPeriod;
             m_randomBackoffPeriodsLeft -= usedBackoffs;
             NS_LOG_DEBUG("No time in CAP to complete backoff delay, deferring to the next CAP");
             m_endCapEvent =
@@ -424,7 +411,7 @@
     else
     {
         // time the PHY takes to switch from Rx to Tx and Tx to Rx
-        transactionSymbols += (m_mac->GetPhy()->aTurnaroundTime * 2);
+        transactionSymbols += (lrwpan::aTurnaroundTime * 2);
     }
     transactionSymbols += m_mac->GetIfsSize();
 
@@ -571,13 +558,13 @@
 }
 
 uint8_t
-LrWpanCsmaCa::GetNB()
+LrWpanCsmaCa::GetNB() const
 {
     return m_NB;
 }
 
 bool
-LrWpanCsmaCa::GetBatteryLifeExtension()
+LrWpanCsmaCa::GetBatteryLifeExtension() const
 {
     return m_macBattLifeExt;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-csmaca.h ns-3.38/src/lr-wpan/model/lr-wpan-csmaca.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-csmaca.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-csmaca.h	2023-03-16 20:54:23.632868500 -0700
@@ -150,22 +150,6 @@
      */
     uint8_t GetMacMaxCSMABackoffs() const;
     /**
-     * Set the number of symbols forming the basic time period used by the
-     * CSMA-CA algorithm.
-     * See IEEE 802.15.4-2006, section 7.4.1, Table 85.
-     *
-     * \param unitBackoffPeriod the period length in symbols
-     */
-    void SetUnitBackoffPeriod(uint64_t unitBackoffPeriod);
-    /**
-     * Get the number of symbols forming the basic time period used by the
-     * CSMA-CA algorithm.
-     * See IEEE 802.15.4-2006, section 7.4.1, Table 85.
-     *
-     * \return the period length in symbols
-     */
-    uint64_t GetUnitBackoffPeriod() const;
-    /**
      * Locates the time to the next backoff period boundary in the SUPERFRAME
      * and returns the amount of time left to this moment.
      *
@@ -249,13 +233,13 @@
      *
      * \returns the number of CSMA retries
      */
-    uint8_t GetNB();
+    uint8_t GetNB() const;
     /**
      * Get the value of the Battery Life Extension
      *
      * \returns  true or false to Battery Life Extension support
      */
-    bool GetBatteryLifeExtension();
+    bool GetBatteryLifeExtension() const;
 
   private:
     void DoDispose() override;
@@ -277,7 +261,7 @@
      */
     bool m_isSlotted;
     /**
-     * The MAC instance for which this CSMA/CA implemenation is configured.
+     * The MAC instance for which this CSMA/CA implementation is configured.
      */
     Ptr<LrWpanMac> m_mac;
     /**
@@ -299,7 +283,7 @@
     /**
      * Minimum backoff exponent. 0 - macMaxBE, default 3
      */
-    uint8_t m_macMinBE; //
+    uint8_t m_macMinBE;
     /**
      * Maximum backoff exponent. 3 - 8, default 5
      */
@@ -309,10 +293,6 @@
      */
     uint8_t m_macMaxCSMABackoffs;
     /**
-     * Number of symbols per CSMA/CA time unit, default 20 symbols.
-     */
-    uint64_t m_aUnitBackoffPeriod;
-    /**
      * Count the number of remaining random backoff periods left to delay.
      */
     uint64_t m_randomBackoffPeriodsLeft;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-fields.h ns-3.38/src/lr-wpan/model/lr-wpan-fields.h
--- ns-3.37/src/lr-wpan/model/lr-wpan-fields.h	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-fields.h	2023-03-16 20:54:23.632868500 -0700
@@ -224,7 +224,7 @@
     /**
      * GTS Descriptor
      */
-    struct gtsDescriptor
+    struct GtsDescriptor
     {
         Mac16Address m_gtsDescDevShortAddr; //!< GTS Descriptor Device Short Address (Bit 0-15)
         uint8_t m_gtsDescStartSlot;         //!< GTS Descriptor GTS Starting Slot(Bit 16-19)
@@ -239,7 +239,7 @@
     uint8_t m_gtsDirMask; //!< GTS Direction field Directions Mask (Bit 0-6)
     // GTS Direction field Reserved (Not Necessary) (Bit 7)
     // GTS List
-    gtsDescriptor m_gtsList[7]; //!< GTS List field (maximum descriptors stored == 7)
+    GtsDescriptor m_gtsList[7]; //!< GTS List field (maximum descriptors stored == 7)
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/lr-wpan/model/lr-wpan-mac.cc ns-3.38/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.37/src/lr-wpan/model/lr-wpan-mac.cc	2022-11-01 17:37:24.515395200 -0700
+++ ns-3.38/src/lr-wpan/model/lr-wpan-mac.cc	2023-03-16 20:54:23.632868500 -0700
@@ -24,6 +24,7 @@
  */
 #include "lr-wpan-mac.h"
 
+#include "lr-wpan-constants.h"
 #include "lr-wpan-csmaca.h"
 #include "lr-wpan-mac-header.h"
 #include "lr-wpan-mac-pl-headers.h"
@@ -202,7 +203,7 @@
     m_channelScanIndex = 0;
     m_maxEnergyLevel = 0;
 
-    m_macResponseWaitTime = aBaseSuperframeDuration * 32;
+    m_macResponseWaitTime = lrwpan::aBaseSuperframeDuration * 32;
     m_assocRespCmdWaitTime = 960;
 
     m_maxTxQueueSize = m_txQueue.max_size();
@@ -213,7 +214,9 @@
     uniformVar->SetAttribute("Max", DoubleValue(255.0));
     m_macDsn = SequenceNumber8(uniformVar->GetValue());
     m_macBsn = SequenceNumber8(uniformVar->GetValue());
-    m_shortAddress = Mac16Address("00:00");
+    m_macBeaconPayload = nullptr;
+    m_macBeaconPayloadLength = 0;
+    m_shortAddress = Mac16Address("FF:FF"); // FF:FF = The address is not assigned.
 }
 
 LrWpanMac::~LrWpanMac()
@@ -266,7 +269,7 @@
     m_mcpsDataIndicationCallback = MakeNullCallback<void, McpsDataIndicationParams, Ptr<Packet>>();
     m_mlmeStartConfirmCallback = MakeNullCallback<void, MlmeStartConfirmParams>();
     m_mlmeBeaconNotifyIndicationCallback =
-        MakeNullCallback<void, MlmeBeaconNotifyIndicationParams, Ptr<Packet>>();
+        MakeNullCallback<void, MlmeBeaconNotifyIndicationParams>();
     m_mlmeSyncLossIndicationCallback = MakeNullCallback<void, MlmeSyncLossIndicationParams>();
     m_mlmePollConfirmCallback = MakeNullCallback<void, MlmePollConfirmParams>();
     m_mlmeScanConfirmCallback = MakeNullCallback<void, MlmeScanConfirmParams>();
@@ -280,7 +283,7 @@
 }
 
 bool
-LrWpanMac::GetRxOnWhenIdle()
+LrWpanMac::GetRxOnWhenIdle() const
 {
     return m_macRxOnWhenIdle;
 }
@@ -348,7 +351,7 @@
     LrWpanMacHeader macHdr(LrWpanMacHeader::LRWPAN_MAC_DATA, m_macDsn.GetValue());
     m_macDsn++;
 
-    if (p->GetSize() > LrWpanPhy::aMaxPhyPacketSize - aMinMPDUOverhead)
+    if (p->GetSize() > lrwpan::aMaxPhyPacketSize - lrwpan::aMinMPDUOverhead)
     {
         // Note, this is just testing maximum theoretical frame size per the spec
         // The frame could still be too large once headers are put on
@@ -795,7 +798,8 @@
     {
         m_numLostBeacons = 0;
         // search for a beacon for a time = incomingSuperframe symbols + 960 symbols
-        searchSymbols = ((uint64_t)1 << m_incomingBeaconOrder) + 1 * aBaseSuperframeDuration;
+        searchSymbols =
+            ((uint64_t)1 << m_incomingBeaconOrder) + 1 * lrwpan::aBaseSuperframeDuration;
         searchBeaconTime = Seconds((double)searchSymbols / symbolRate);
         m_beaconTrackingOn = true;
         m_trackingEvent =
@@ -823,6 +827,40 @@
 }
 
 void
+LrWpanMac::MlmeSetRequest(LrWpanMacPibAttributeIdentifier id, Ptr<LrWpanMacPibAttributes> attribute)
+{
+    MlmeSetConfirmParams confirmParams;
+    switch (id)
+    {
+    case macBeaconPayload:
+        if (attribute->macBeaconPayload->GetSize() > lrwpan::aMaxBeaconPayloadLenght)
+        {
+            confirmParams.m_status = MLMESET_INVALID_PARAMETER;
+        }
+        else
+        {
+            confirmParams.m_status = MLMESET_SUCCESS;
+            m_macBeaconPayload = attribute->macBeaconPayload;
+            m_macBeaconPayloadLength = attribute->macBeaconPayload->GetSize();
+        }
+        break;
+    case macBeaconPayloadLength:
+        confirmParams.m_status = MLMESET_INVALID_PARAMETER;
+        break;
+    default:
+        // TODO: Add support for setting other attributes
+        confirmParams.m_status = MLMESET_UNSUPPORTED_ATTRIBUTE;
+        break;
+    }
+
+    if (!m_mlmeSetConfirmCallback.IsNull())
+    {
+        confirmParams.id = id;
+        m_mlmeSetConfirmCallback(confirmParams);
+    }
+}
+
+void
 LrWpanMac::SendOneBeacon()
 {
     NS_LOG_FUNCTION(this);
@@ -831,9 +869,18 @@
     LrWpanMacHeader macHdr(LrWpanMacHeader::LRWPAN_MAC_BEACON, m_macBsn.GetValue());
     m_macBsn++;
     BeaconPayloadHeader macPayload;
-    Ptr<Packet> beaconPacket = Create<Packet>();
+    Ptr<Packet> beaconPacket;
     LrWpanMacTrailer macTrailer;
 
+    if (m_macBeaconPayload == nullptr)
+    {
+        beaconPacket = Create<Packet>();
+    }
+    else
+    {
+        beaconPacket = m_macBeaconPayload;
+    }
+
     macHdr.SetDstAddrMode(LrWpanMacHeader::SHORTADDR);
     macHdr.SetDstAddrFields(GetPanId(), Mac16Address("ff:ff"));
 
@@ -1140,9 +1187,9 @@
             m_fnlCapSlot = 15;
 
             m_beaconInterval =
-                (static_cast<uint32_t>(1 << m_macBeaconOrder)) * aBaseSuperframeDuration;
-            m_superframeDuration =
-                (static_cast<uint32_t>(1 << m_macSuperframeOrder)) * aBaseSuperframeDuration;
+                (static_cast<uint32_t>(1 << m_macBeaconOrder)) * lrwpan::aBaseSuperframeDuration;
+            m_superframeDuration = (static_cast<uint32_t>(1 << m_macSuperframeOrder)) *
+                                   lrwpan::aBaseSuperframeDuration;
 
             // TODO: change the beacon sending according to the startTime parameter (if not PAN
             // coordinator)
@@ -1415,7 +1462,7 @@
 {
     uint64_t symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
 
-    if (m_numLostBeacons > aMaxLostBeacons)
+    if (m_numLostBeacons > lrwpan::aMaxLostBeacons)
     {
         MlmeSyncLossIndicationParams syncLossParams;
         // syncLossParams.m_logCh =
@@ -1433,7 +1480,8 @@
         // Search for one more beacon
         uint64_t searchSymbols;
         Time searchBeaconTime;
-        searchSymbols = ((uint64_t)1 << m_incomingBeaconOrder) + 1 * aBaseSuperframeDuration;
+        searchSymbols =
+            ((uint64_t)1 << m_incomingBeaconOrder) + 1 * lrwpan::aBaseSuperframeDuration;
         searchBeaconTime = Seconds((double)searchSymbols / symbolRate);
         m_trackingEvent =
             Simulator::Schedule(searchBeaconTime, &LrWpanMac::BeaconSearchTimeout, this);
@@ -1591,6 +1639,12 @@
 }
 
 void
+LrWpanMac::SetMlmeSetConfirmCallback(MlmeSetConfirmCallback c)
+{
+    m_mlmeSetConfirmCallback = c;
+}
+
+void
 LrWpanMac::PdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi)
 {
     NS_ASSERT(m_lrWpanMacState == MAC_IDLE || m_lrWpanMacState == MAC_ACK_PENDING ||
@@ -1785,7 +1839,7 @@
                 if (acceptFrame && (m_csmaCa->IsSlottedCsmaCa() && m_capEvent.IsRunning()))
                 {
                     Time timeLeftInCap = Simulator::GetDelayLeft(m_capEvent);
-                    uint64_t ackSymbols = m_phy->aTurnaroundTime + m_phy->GetPhySHRDuration() +
+                    uint64_t ackSymbols = lrwpan::aTurnaroundTime + m_phy->GetPhySHRDuration() +
                                           ceil(6 * m_phy->GetPhySymbolsPerOctet());
                     Time ackTime = Seconds((double)ackSymbols / symbolRate);
 
@@ -1935,9 +1989,9 @@
 
                         m_incomingBeaconInterval =
                             (static_cast<uint32_t>(1 << m_incomingBeaconOrder)) *
-                            aBaseSuperframeDuration;
+                            lrwpan::aBaseSuperframeDuration;
                         m_incomingSuperframeDuration =
-                            aBaseSuperframeDuration *
+                            lrwpan::aBaseSuperframeDuration *
                             (static_cast<uint32_t>(1 << m_incomingSuperframeOrder));
 
                         if (incomingSuperframe.IsBattLifeExt())
@@ -1982,7 +2036,7 @@
                                 beaconParams.m_panDescriptor = panDescriptor;
                                 beaconParams.m_sduLength = p->GetSize();
                                 beaconParams.m_sdu = p;
-                                m_mlmeBeaconNotifyIndicationCallback(beaconParams, originalPkt);
+                                m_mlmeBeaconNotifyIndicationCallback(beaconParams);
                             }
                         }
 
@@ -2039,7 +2093,7 @@
 
                                 searchSymbols =
                                     (static_cast<uint64_t>(1 << m_incomingBeaconOrder)) +
-                                    1 * aBaseSuperframeDuration;
+                                    1 * lrwpan::aBaseSuperframeDuration;
                                 searchBeaconTime =
                                     Seconds(static_cast<double>(searchSymbols / symbolRate));
                                 m_trackingEvent =
@@ -2068,7 +2122,9 @@
                             MlmeBeaconNotifyIndicationParams beaconParams;
                             beaconParams.m_bsn = receivedMacHdr.GetSeqNum();
                             beaconParams.m_panDescriptor = panDescriptor;
-                            m_mlmeBeaconNotifyIndicationCallback(beaconParams, originalPkt);
+                            beaconParams.m_sduLength = p->GetSize();
+                            beaconParams.m_sdu = p;
+                            m_mlmeBeaconNotifyIndicationCallback(beaconParams);
                         }
                     }
                 }
@@ -2507,12 +2563,12 @@
     if (m_macBeaconOrder == 15)
     {
         // Non-beacon enabled mode
-        unit = aBaseSuperframeDuration * m_macTransactionPersistenceTime;
+        unit = lrwpan::aBaseSuperframeDuration * m_macTransactionPersistenceTime;
     }
     else
     {
         // Beacon-enabled mode
-        unit = ((static_cast<uint32_t>(1) << m_macBeaconOrder) * aBaseSuperframeDuration) *
+        unit = ((static_cast<uint32_t>(1) << m_macBeaconOrder) * lrwpan::aBaseSuperframeDuration) *
                m_macTransactionPersistenceTime;
     }
 
@@ -2789,7 +2845,7 @@
                 if (!m_mcpsDataConfirmCallback.IsNull())
                 {
                     McpsDataConfirmParams confirmParams;
-                    NS_ASSERT_MSG(m_txQueue.size() > 0, "TxQsize = 0");
+                    NS_ASSERT_MSG(!m_txQueue.empty(), "TxQsize = 0");
                     Ptr<TxQueueElement> txQElement = m_txQueue.front();
                     confirmParams.m_msduHandle = txQElement->txQMsduHandle;
                     confirmParams.m_status = IEEE_802_15_4_SUCCESS;
@@ -2838,12 +2894,12 @@
                     case CommandPayloadHeader::SUCCESSFUL:
                         confirmParams.m_status =
                             LrWpanMlmeAssociateConfirmStatus::MLMEASSOC_SUCCESS;
-                        confirmParams.m_assocShortAddr =
-                            GetShortAddress(); // the original short address used in the association
-                                               // request
-                        SetShortAddress(
-                            receivedMacPayload
-                                .GetShortAddr()); // the assigned short address by the coordinator
+                        // The original short address used in the association
+                        // used in the association request
+                        confirmParams.m_assocShortAddr = GetShortAddress();
+
+                        // The assigned short address by the coordinator
+                        SetShortAddress(receivedMacPayload.GetShortAddr());
                         m_macPanId = receivedMacHdr.GetSrcPanId();
                         break;
                     case CommandPayloadHeader::FULL_CAPACITY:
@@ -2894,7 +2950,7 @@
     {
         if (!macHdr.IsAcknowledgment())
         {
-            NS_ASSERT_MSG(m_txQueue.size() > 0, "TxQsize = 0");
+            NS_ASSERT_MSG(!m_txQueue.empty(), "TxQsize = 0");
             Ptr<TxQueueElement> txQElement = m_txQueue.front();
             m_macTxDropTrace(txQElement->txQPkt);
             if (!m_mcpsDataConfirmCallback.IsNull())
@@ -3059,7 +3115,7 @@
         if (status == LrWpanPhyEnumeration::IEEE_802_15_4_PHY_SUCCESS)
         {
             uint64_t symbolRate = static_cast<uint64_t>(m_phy->GetDataOrSymbolRate(false));
-            uint64_t scanDuration = aBaseSuperframeDuration *
+            uint64_t scanDuration = lrwpan::aBaseSuperframeDuration *
                                     ((static_cast<uint32_t>(1 << m_scanParams.m_scanDuration)) + 1);
             Time nextScanTime = Seconds(static_cast<double>(scanDuration / symbolRate));
 
@@ -3432,7 +3488,7 @@
 uint64_t
 LrWpanMac::GetMacAckWaitDuration() const
 {
-    return m_csmaCa->GetUnitBackoffPeriod() + m_phy->aTurnaroundTime + m_phy->GetPhySHRDuration() +
+    return lrwpan::aUnitBackoffPeriod + lrwpan::aTurnaroundTime + m_phy->GetPhySHRDuration() +
            ceil(6 * m_phy->GetPhySymbolsPerOctet());
 }
 
@@ -3483,7 +3539,7 @@
 {
     NS_ASSERT(m_txPkt);
 
-    if (m_txPkt->GetSize() <= aMaxSIFSFrameSize)
+    if (m_txPkt->GetSize() <= lrwpan::aMaxSIFSFrameSize)
     {
         return m_macSIFSPeriod;
     }
